diff a/.github/scripts/update-version.sh b/.github/scripts/update-version.sh
--- /dev/null
+++ b/.github/scripts/update-version.sh
@@ -0,0 +1,22 @@
+#!/bin/bash
+
+set -x
+
+UPSTREAM_REMOTE=$1
+
+# Load the current OpenJDK version
+source make/conf/version-numbers.conf
+
+BUILD_NUMBER=$(git ls-remote --tags ${UPSTREAM_REMOTE} |grep jdk-${DEFAULT_VERSION_FEATURE}+ | grep -vE "(-ga|{})$" | cut -d+ -f 2 |sort -n |tail -1)
+
+# Load the current Corretto version
+CURRENT_VERSION=$(cat version.txt)
+
+if [[ ${CURRENT_VERSION} == ${DEFAULT_VERSION_FEATURE}.${DEFAULT_VERSION_INTERIM}.${DEFAULT_VERSION_UPDATE}.${BUILD_NUMBER:=0}.* ]]; then
+    echo "Corretto version is current."
+else
+    echo "Updating Corretto version"
+    NEW_VERSION="${DEFAULT_VERSION_FEATURE}.${DEFAULT_VERSION_INTERIM}.${DEFAULT_VERSION_UPDATE}.${BUILD_NUMBER}.1"
+    echo  "${NEW_VERSION}" > version.txt
+    git commit -m "Update Corretto version to match upstream: ${NEW_VERSION}" version.txt
+fi
diff a/.gitignore b/.gitignore
--- a/.gitignore
+++ b/.gitignore
@@ -1,10 +1,9 @@
 /build/
 /dist/
 /.idea/
 /.vscode/
-/nbproject/
 nbproject/private/
 /webrev
 /.src-rev
 /.jib/
 .DS_Store
@@ -13,13 +12,17 @@
 test/nashorn/script/external
 test/nashorn/lib
 NashornProfile.txt
 **/JTreport/**
 **/JTwork/**
+/.gradle/
+.gradletasknamecache
+/pre-build/
 /src/utils/LogCompilation/target/
 /.project/
 /.settings/
+commitId.txt
 /compile_commands.json
 /.cache
 /.gdbinit
 /.lldbinit
 **/core.[0-9]*
diff a/README.JAVASE b/README.JAVASE
--- /dev/null
+++ b/README.JAVASE
@@ -0,0 +1,4 @@
+This is an intermediate build made available for testing purposes only.
+The code is untested and presumed incompatible with the Java SE Specification.
+You should not deploy or write to this code, but instead use a tested and certified Java SE compatible version of the code.
+Redistribution of this build must retain this notice.
diff a/build.gradle b/build.gradle
--- /dev/null
+++ b/build.gradle
@@ -0,0 +1,323 @@
+/*
+ * Copyright Amazon.com Inc. or its affiliates. All Rights Reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation. Amazon designates this
+ * particular file as subject to the "Classpath" exception as provided
+ * by Oracle in the LICENSE file that accompanied this code.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ */
+
+// Tasks can refer to version information using the project.version
+// property. For an example of its usage, see ':installers:linux:rpm:buildLogic'
+// where the version numbers are used to populate a templated RPM spec file.
+
+import org.apache.tools.ant.taskdefs.condition.Os
+
+allprojects {
+    apply plugin: 'base'
+
+    configurations {
+        compile {
+            transitive = false
+        }
+    }
+
+    version = {
+        def full = file('version.txt').text.trim()
+        def tokens = full.tokenize(".")
+        [full    : full,
+         major   : tokens[0],
+         minor   : tokens[1],
+         security: tokens[2],
+         build   : tokens[3],
+         revision: tokens[4],
+         upstream: "${tokens[0]}.${tokens[1]}.${tokens[2]}.${tokens[3]}".toString()]
+    }.call()
+    buildDir = 'corretto-build'
+
+    ext {
+        buildRoot = file("$buildDir/buildRoot")
+        distributionDir = file("$buildDir/distributions")
+        packageInfo = [
+                url       : "https://github.com/corretto/corretto-${project.version.major}",
+                vendor    : 'Amazon',
+                packager  : 'Amazon',
+                description  : 'Amazon Corretto\'s packaging of the runtime core elements of the OpenJDK code.',
+                license   : 'ASL 1.1 and ASL 2.0 and BSD and BSD with advertising and GPL+ and GPLv2 and GPLv2 with ' +
+                        'exceptions and IJG and LGPLv2+ and MIT and MPLv2.0 and Public Domain and W3C and zlib and ' +
+                        'ISC and FTL and RSA.',
+                maintainer: 'Amazon Corretto Team <corretto-team@amazon.com>',
+                buildHost : 'build.amazon.com'
+        ]
+        jdkTools = ['java', 'keytool', 'rmid', 'rmiregistry', 'jjs', 'pack200', 'unpack200', 'javac', 'jaotc', 'jlink',
+            'jmod', 'jhsdb', 'jar', 'jarsigner', 'javadoc', 'javap', 'jcmd', 'jconsole', 'jdb', 'jdeps', 'jdeprscan',
+            'jimage', 'jinfo', 'jmap', 'jps', 'jrunscript', 'jshell', 'jstack', 'jstat', 'jstatd', 'rmic', 'serialver']
+        // artifact names
+        caCerts = "cacerts"
+        sourceTar = "amazon-corretto-source-${project.version.full}.tar.gz"
+
+        configurationFiles = [
+            'conf/logging.properties',
+            'conf/net.properties',
+            'conf/sound.properties',
+            'conf/security/policy/limited/default_local.policy',
+            'conf/security/policy/limited/exempt_local.policy',
+            'conf/security/policy/limited/default_US_export.policy',
+            'conf/security/policy/unlimited/default_local.policy',
+            'conf/security/policy/unlimited/default_US_export.policy',
+            'conf/security/java.security',
+            'conf/management/jmxremote.access',
+            'conf/management/management.properties',
+            'lib/security/blocked.certs',
+            'lib/security/public_suffix_list.dat'
+            ];
+
+        correttoCommonFlags = [
+                "--with-freetype=bundled",
+                '--with-jvm-features=zgc',
+                "--with-version-build=${project.version.build}",
+                '--with-version-pre=',
+                "--with-vendor-bug-url=https://github.com/corretto/corretto-${project.version.major}/issues/",
+                "--with-vendor-vm-bug-url=https://github.com/corretto/corretto-${project.version.major}/issues/",
+                '--with-vendor-name=Amazon.com Inc.',
+                '--with-vendor-url=https://aws.amazon.com/corretto/',
+                "--with-vendor-version-string=Corretto-${project.version.full}"
+        ]
+
+        // If this is a certified release build, exclude the README.JAVASE file
+        excludeReadmeJavaSE = Boolean.parseBoolean(project.findProperty("corretto.excludeReadmeJavaSE"))
+        rootFiles = ['ADDITIONAL_LICENSE_INFO', 'ASSEMBLY_EXCEPTION', 'LICENSE', 'README.md', 'commitId.txt', 'version.txt']
+        if (!excludeReadmeJavaSE) {
+            rootFiles += 'README.JAVASE'
+        }
+
+        // If the version opt is empty, then the JDK will set to  'adhoc.<username>.<base dir name>'
+        versionOpt = project.findProperty("corretto.versionOpt") ?: "LTS" // Set the LTS when needed
+        correttoCommonFlags += ["--with-version-opt=${versionOpt}"]
+
+        def versionDate = project.findProperty("corretto.versionDate")
+        if (versionDate) {
+            correttoCommonFlags += ["--with-version-date=${versionDate}"]
+        }
+
+        def gtest = project.findProperty("corretto.gtest")
+        if (gtest) {
+            correttoCommonFlags += ["--with-gtest=${gtest}"]
+        }
+
+        // This should be public so we can know if we should build the micro-benchmarks
+        jmh = project.findProperty("corretto.jmh")
+        if (jmh) {
+            correttoCommonFlags += ["--with-jmh=${jmh}"]
+        }
+
+        // If asyncProfilerBinariesPath provided, store for easy reference when bundling
+        asyncProfilerBinariesPath = project.findProperty("asyncProfilerBinariesPath") ?: ""
+        asyncProfilerLegal = "${rootDir}/installers/legal/async-profiler.md"
+
+        // Valid value: null, release, debug, fastdebug, slowdebug
+        correttoDebugLevel = "release" // Default: release
+        switch(project.findProperty("corretto.debug_level")) {
+            case null:
+            case "release":
+                correttoCommonFlags += ['--with-debug-level=release', '--with-native-debug-symbols=zipped']
+                break
+            case "fastdebug":
+                correttoDebugLevel = "fastdebug"
+                correttoCommonFlags += ['--with-debug-level=fastdebug', '--with-native-debug-symbols=zipped']
+                break
+            case "debug":
+            case "slowdebug":
+                correttoDebugLevel = "slowdebug"
+                correttoCommonFlags += ['--with-debug-level=slowdebug', '--with-native-debug-symbols=external']
+                break
+            default:
+                throw new RuntimeException("Invalid corretto.debug_level")
+        }
+
+        // customized flags. Identify the index of double dashes as the start of a flag
+        String extraConfig = project.findProperty("corretto.extra_config")
+        def lastIndex = -1
+        if (extraConfig != null) {
+            for (int index = extraConfig.indexOf("--"); index >= 0; index = extraConfig.indexOf("--", index + 1)) {
+                if (lastIndex != -1) {
+                    correttoCommonFlags += extraConfig.substring(lastIndex, index).trim()
+                }
+                lastIndex = index
+            }
+            if (lastIndex != -1) {
+                correttoCommonFlags += extraConfig.substring(lastIndex).trim()
+            }
+        }
+
+        // Determine the system architecture
+        def jdkArch = ""
+        def os = ""
+        if (Os.isFamily(Os.FAMILY_MAC)) {
+            os = 'macosx'
+            nativeArch = ['uname', '-m'].execute().text.trim()
+            if (nativeArch == "arm64") {
+                jdkArch = "aarch64"
+            } else {
+                jdkArch = "x86_64"
+            }
+        } else if (Os.isFamily(Os.FAMILY_UNIX)) {
+            os = 'linux'
+            jdkArch = ['uname', '-m'].execute().text.trim()
+            // `uname -m` returns the host arch in a linux x86 docker instance. Pass a flag
+            // to enable
+            if (project.hasProperty("x86") && Boolean.parseBoolean(project.getProperty('x86'))) {
+                jdkArch = "x86"
+            }
+        } else if (Os.isFamily(Os.FAMILY_WINDOWS)) {
+            os = 'windows'
+            def arch = System.getenv('PROCESSOR_ARCHITECTURE')
+            if (arch == 'AMD64') {
+                jdkArch = "x86_64"
+            } else { //x86
+                throw new GradleException("${arch} is not suported")
+            }
+        } else {
+            throw new GradleException("OS is not supported")
+        }
+
+        // Ext property: correttoArch
+        switch (jdkArch) {
+            case 'x86':
+            case 'aarch64':
+                correttoArch = jdkArch
+                break
+            case 'x86_64':
+                correttoArch = 'x64'
+                break
+            default:
+                throw new GradleException("${jdkArch} is not supported")
+        }
+
+        // Call toString explicitly to avoid lazy evaluation
+        jdkImageName = "${os}-${jdkArch}-server-${correttoDebugLevel}".toString()
+        // no debug level suffix for release build
+        if (correttoDebugLevel == "release") {
+            correttoJdkArchiveName = "amazon-corretto-${project.version.full}-${os}-${correttoArch}".toString()
+        } else {
+            correttoJdkArchiveName =
+                    "amazon-corretto-${project.version.full}-${os}-${correttoArch}-${correttoDebugLevel}".toString()
+        }
+        correttoDebugSymbolsArchiveName = "amazon-corretto-debugsymbols-${project.version.full}-${os}-${correttoArch}".toString()
+        correttoTestImageArchiveName = "amazon-corretto-testimage-${project.version.full}-${os}-${correttoArch}".toString()
+    }
+}
+
+project(':prebuild') {
+    apply plugin: 'java'
+
+    configurations {
+        cacerts
+    }
+
+    ext {
+        cacertDir = "$distributionDir/${project.caCerts}"
+    }
+
+    def preBuildSrc = "src"
+    def classPath = "classes"
+    def generateToolMain = "build.tools.generatecacerts.GenerateCacerts"
+
+    task copyToolSrc(type: Copy) {
+        description = 'Copy utility tool source to the project root'
+        from fileTree("$rootDir/make/jdk/src/classes") {
+            include 'build/tools/generatecacerts/*'
+        }
+        into preBuildSrc
+    }
+
+    task buildTool(type: JavaCompile) {
+        dependsOn copyToolSrc
+        source = fileTree(dir: preBuildSrc, include: '**/*.java')
+        destinationDirectory = file(classPath)
+        classpath = files(classPath)
+    }
+
+    task generateJdkCacerts(type: JavaExec) {
+        dependsOn buildTool
+        def jdkCaDir = "$rootDir/src/java.base/share/data/cacerts"
+
+        description = 'Generate Cacerts from JDK source'
+        classpath = files(classPath)
+
+        // See commit for [JDK-8275252](https://github.com/corretto/corretto-jdk/commit/bd2b41dd7062c50f3aaebec2137d5fdd9546c120)
+        jvmArgs = ['-Dkeystore.pkcs12.certProtectionAlgorithm=NONE', '-Dkeystore.pkcs12.macAlgorithm=NONE']
+        mainClass = generateToolMain
+        args = [jdkCaDir, project.caCerts]
+    }
+
+    task importAmazonCacerts(type: Exec) {
+        dependsOn generateJdkCacerts
+        // Default password for JSSE key store
+        def keystore_password = "changeit"
+        commandLine 'keytool', '-importkeystore', '-noprompt',
+                '-srckeystore', "$rootDir/amazon-cacerts",
+                '-srcstorepass', keystore_password,
+                '-destkeystore', caCerts,
+                '-deststorepass', ''
+    }
+
+    task copyCacerts(type: Copy) {
+        dependsOn importAmazonCacerts
+        from caCerts
+        into distributionDir
+    }
+
+    artifacts {
+        cacerts file: file("$distributionDir/${caCerts}"), builtBy: copyCacerts
+    }
+}
+
+project(':openjdksrc') {
+    /**
+     * Compresses a snapshot of the source code used to perform the build.
+     */
+    task sourceDistributionTarball(type: Tar) {
+        description = 'Assemble source files required for building and distributing Corretto.'
+        compression = Compression.GZIP
+        archiveFileName = sourceTar
+        def sourceTarRootFiles = ['LICENSE',
+                    'ADDITIONAL_LICENSE_INFO',
+                    'README',
+                    'README.md',
+                    'ASSEMBLY_EXCEPTION',
+                    'commitId.txt',
+                    'version.txt',
+                    'amazon-cacerts',
+                    'configure',
+                    'Makefile',
+                    'bin/**',
+                    'doc/**',
+                    'make/**',
+                    'src/**',
+                    'test/**']
+        if (!excludeReadmeJavaSE) {
+            sourceTarRootFiles += 'README.JAVASE'
+        }
+
+        from fileTree(rootDir) {
+            include sourceTarRootFiles
+        }
+    }
+
+    artifacts {
+        archives sourceDistributionTarball
+    }
+}
diff a/gradlew.bat b/gradlew.bat
--- /dev/null
+++ b/gradlew.bat
@@ -0,0 +1,94 @@
+@rem
+@rem Copyright 2015 the original author or authors.
+@rem
+@rem Licensed under the Apache License, Version 2.0 (the "License");
+@rem you may not use this file except in compliance with the License.
+@rem You may obtain a copy of the License at
+@rem
+@rem      https://www.apache.org/licenses/LICENSE-2.0
+@rem
+@rem Unless required by applicable law or agreed to in writing, software
+@rem distributed under the License is distributed on an "AS IS" BASIS,
+@rem WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+@rem See the License for the specific language governing permissions and
+@rem limitations under the License.
+@rem
+@rem SPDX-License-Identifier: Apache-2.0
+@rem
+
+@if "%DEBUG%"=="" @echo off
+@rem ##########################################################################
+@rem
+@rem  Gradle startup script for Windows
+@rem
+@rem ##########################################################################
+
+@rem Set local scope for the variables with windows NT shell
+if "%OS%"=="Windows_NT" setlocal
+
+set DIRNAME=%~dp0
+if "%DIRNAME%"=="" set DIRNAME=.
+@rem This is normally unused
+set APP_BASE_NAME=%~n0
+set APP_HOME=%DIRNAME%
+
+@rem Resolve any "." and ".." in APP_HOME to make it shorter.
+for %%i in ("%APP_HOME%") do set APP_HOME=%%~fi
+
+@rem Add default JVM options here. You can also use JAVA_OPTS and GRADLE_OPTS to pass JVM options to this script.
+set DEFAULT_JVM_OPTS="-Xmx64m" "-Xms64m"
+
+@rem Find java.exe
+if defined JAVA_HOME goto findJavaFromJavaHome
+
+set JAVA_EXE=java.exe
+%JAVA_EXE% -version >NUL 2>&1
+if %ERRORLEVEL% equ 0 goto execute
+
+echo. 1>&2
+echo ERROR: JAVA_HOME is not set and no 'java' command could be found in your PATH. 1>&2
+echo. 1>&2
+echo Please set the JAVA_HOME variable in your environment to match the 1>&2
+echo location of your Java installation. 1>&2
+
+goto fail
+
+:findJavaFromJavaHome
+set JAVA_HOME=%JAVA_HOME:"=%
+set JAVA_EXE=%JAVA_HOME%/bin/java.exe
+
+if exist "%JAVA_EXE%" goto execute
+
+echo. 1>&2
+echo ERROR: JAVA_HOME is set to an invalid directory: %JAVA_HOME% 1>&2
+echo. 1>&2
+echo Please set the JAVA_HOME variable in your environment to match the 1>&2
+echo location of your Java installation. 1>&2
+
+goto fail
+
+:execute
+@rem Setup the command line
+
+set CLASSPATH=
+
+
+@rem Execute Gradle
+"%JAVA_EXE%" %DEFAULT_JVM_OPTS% %JAVA_OPTS% %GRADLE_OPTS% "-Dorg.gradle.appname=%APP_BASE_NAME%" -classpath "%CLASSPATH%" -jar "%APP_HOME%\gradle\wrapper\gradle-wrapper.jar" %*
+
+:end
+@rem End local scope for the variables with windows NT shell
+if %ERRORLEVEL% equ 0 goto mainEnd
+
+:fail
+rem Set variable GRADLE_EXIT_CONSOLE if you need the _script_ return code instead of
+rem the _cmd.exe /c_ return code!
+set EXIT_CODE=%ERRORLEVEL%
+if %EXIT_CODE% equ 0 set EXIT_CODE=1
+if not ""=="%GRADLE_EXIT_CONSOLE%" exit %EXIT_CODE%
+exit /b %EXIT_CODE%
+
+:mainEnd
+if "%OS%"=="Windows_NT" endlocal
+
+:omega
diff a/installers/linux/al2/spec/build.gradle b/installers/linux/al2/spec/build.gradle
--- /dev/null
+++ b/installers/linux/al2/spec/build.gradle
@@ -0,0 +1,98 @@
+/*
+ * Copyright Amazon.com Inc. or its affiliates. All Rights Reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation. Amazon designates this
+ * particular file as subject to the "Classpath" exception as provided
+ * by Oracle in the LICENSE file that accompanied this code.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ */
+
+import groovy.text.GStringTemplateEngine
+
+dependencies {
+    compile project(path: ':openjdksrc', configuration: 'archives')
+}
+
+def tarName = "java-${version.major}-amazon-corretto"
+def tarVersion = "${version.major}.${version.minor}.${version.security}+${version.build}"
+
+def javaVersion = "${version.major}.${version.minor}.${version.security}"
+def buildId = "${version.build}"
+def releaseId = "${version.revision}"
+/**
+ * Apply version numbers to the RPM spec file template and copy
+ * to the build root.
+ */
+task inflateRpmSpec {
+    inputs.file 'java-amazon-corretto.spec.template'
+    outputs.file "$buildDir/java-${version.major}-amazon-corretto.spec"
+    doLast {
+        def renderedTemplate = new GStringTemplateEngine()
+                .createTemplate(file('java-amazon-corretto.spec.template'))
+                .make(
+                [
+                    java_spec_version   : version.major,
+                    java_major_version   : version.major,
+                    java_security_version   : version.security,
+                    java_version        : javaVersion,
+                    build_id            : buildId,
+                    release_id          : releaseId,
+                    version_opt         : versionOpt,
+                    debug_level         : correttoDebugLevel,
+                    boot_jdk_major_version : version.major.toInteger() - 1,
+                    boot_jdk_major_v_backup : version.major.toInteger() - 2,
+                    experimental_feature: project.findProperty("corretto.experimental_feature") ?: "%{nil}",
+                    additional_configure_options: project.findProperty("corretto.additional_configure_options") ?: "%{nil}",
+                    zlib_option: project.findProperty("corretto.zlib_option") ?: "system",
+                    use_gcc_ver: project.findProperty("corretto.use_gcc_ver") ?: "%{nil}"
+                ])
+        outputs.files.singleFile.text = renderedTemplate
+    }
+}
+
+task copySourceTar(type: Tar) {
+    dependsOn project.configurations.compile, inflateRpmSpec
+    compression = Compression.GZIP
+    archiveFileName = project.configurations.compile.singleFile.name
+    from("$buildDir") {
+        include "java-${project.version.major}-amazon-corretto.spec"
+        into 'rpm'
+    }
+    from(tarTree(project.configurations.compile.singleFile)) {
+        into '/'
+    }
+    // Include the man pages tarball if it exists
+    from(file("${buildDir}/distributions/jdk${project.version.major}-manpages.tar.gz")) {
+        into '/'
+    }
+}
+
+task rpmBuild(type: Exec) {
+    dependsOn copySourceTar
+    workingDir "$buildDir"
+    executable = '/usr/bin/rpmbuild'
+    args  = ['-vv',
+        '-bs',
+        '--define',
+        "dist .${project.findProperty('corretto.amzn_dist') ?: 'amzn2'}",
+        '--define',
+        "_topdir ${buildDir}/rpmbuild",
+        '--define',
+        "_sourcedir ${buildDir}/distributions",
+        '--define',
+        "_srcrpmdir ${buildDir}/distributions",
+        "java-${version.major}-amazon-corretto.spec"]
+
+}
